Description

Scoped search fails with internal server error on postgresql if the searched value can't be converted to a type of the column it's

compared against. This happens for example when the search query tries to compare empty string with integer column.

Reproducible with hammer:

hammer filter list --search 'role_id = ""'

hammer filter list --search 'role_id = a'

 Results in:

PG::Error: ERROR:  invalid input syntax for integer: "a" 

LINE 1: ..."id" = "filters"."role_id" WHERE (("roles"."id" = 'a'))  ORD...

                                                             ^

: SELECT  "filters"."id" AS t0_r0, "filters"."search" AS t0_r1, "filters"."role_id" AS t0_r2, "fil

ters"."created_at" AS t0_r3, "filters"."updated_at" AS t0_r4, "filters"."taxonomy_search" AS t0_r5

, "roles"."id" AS t1_r0, "roles"."name" AS t1_r1, "roles"."builtin" AS t1_r2, "roles"."permissions

" AS t1_r3 FROM "filters" LEFT OUTER JOIN "roles" ON "roles"."id" = "filters"."role_id" WHERE (("r

oles"."id" = 'a'))  ORDER BY filters.role_id, filters.id LIMIT 1000 OFFSET 0

Related issues:

Related to Hammer CLI - Bug #13064: Executing "hammer role filters" command t... Closed 01/08/2016

Has duplicate Foreman - Bug #14235: Executing "hammer role filters" command t... Duplicate 03/16/2016

History

#1 - 02/10/2016 08:54 AM - Tomáš Strachota

- Related to Bug #13064: Executing "hammer role filters" command throws SQL errors added

#2 - 02/14/2016 11:51 AM - Shimon Shtein

role_id filter parameter is set to string in api/v2/filters_controller.rb Probably needs change to integer. In addition we need to set validation in

hammer-cli based on apipie type reported.

#3 - 03/16/2016 11:33 AM - Dominic Cleal

- Has duplicate Bug #14235: Executing "hammer role filters" command throws SQL errors added

#4 - 03/16/2016 11:56 AM - Brad Buckingham

- Bugzilla link set to 1296782

#5 - 08/23/2016 07:44 AM - Bryan Kearney

- Status changed from New to Duplicate

Duplicate of 13064
#6 - 08/23/2016 07:47 AM - Dominic Cleal

- Status changed from Duplicate to New

This isn't a duplicate, #13064 is filed against Hammer CLI and this is filed against Foreman's search feature. The server error is a valid bug report

irrespective of a CLI fix.
